      subroutine restart_in(nstep0, dtime0, flnm, flnmh)
      use mod_xc  ! HYCOM communication interface
      use mod_za  ! HYCOM I/O interface
      implicit none
c
!DBI:      include 'common_blocks.h'
c
      integer nstep0
      real*8  dtime0
c
c     read in a restart file on unit 11.
c
      integer   i,ios,j,k,ktr
      character cline*80
      character*(*) :: flnm, flnmh
c
      if (mnproc.eq.1) then
        write(lp,*)'DBI: (restart_in) opening restartfile...'
        call flush(lp)
      endif

      call zaiopf(trim(flnm),'old', 11)

      if     (mnproc.eq.1) then  
        open (unit=11,file=flnmh,status='old',action='read',form='formatted')
      endif
      call zagetc(cline,ios, 11)
      if     (ios.ne.0) then
        if     (mnproc.eq.1) then
          write(lp,'(/ a,i4,i9 /)')
     &      'I/O error from zagetc, iunit,ios = ',11,ios
        endif !1st tile
        call xcstop('(restart_in)')
               stop '(restart_in)'
      endif

      if     (mnproc.eq.1) then
        write(lp,'(a)') cline(1:len_trim(cline))
        call flush (lp)
      endif !1st tile

      if     (cline(1:9).ne.'RESTART:') then
        if     (mnproc.eq.1) then
          write(lp,'(/ a /)') 'error in hycom - ice restart failed'
          call flush (lp)
        endif !1st tile
        call ccsm3_exit_HYCOM('ERROR: restart_in',normal_exit=.false.)
      endif

      call zagetc(cline,ios, 11)


      if     (ios.ne.0) then
        if     (mnproc.eq.1) then
          write(lp,'(/ a,i4,i9 /)')
     &      'I/O error from zagetc, iunit,ios = ',11,ios
        endif !1st tile
        call xcstop('(restart_in)')
               stop '(restart_in)'
      endif
      if     (mnproc.eq.1) then
      write(lp,'(a)') cline(1:len_trim(cline))
      call flush(lp)
      endif !1st tile
      i = index(cline,'=')
      read(cline(i+1:),*) nstep0,dtime0
c
      if (mnproc.eq.1) then
        write(lp,*)'DBI: (restart_in) calling restart_in3d...'
        call flush(lp)
      endif

      call restart_in3d(u,     2*kdm, iu, 'u       ')
      if (mnproc.eq.1) then
        write(lp,*)'DBI: (restart_in) u got!'
        call flush(lp)
      endif
      call restart_in3d(v,     2*kdm, iv, 'v       ')
      if (mnproc.eq.1) then
        write(lp,*)'DBI: (restart_in) v got!'
        call flush(lp)
      endif
      call restart_in3d(dp,    2*kdm, ip, 'dp      ')
      if (mnproc.eq.1) then
        write(lp,*)'DBI: (restart_in) dp got!'
        call flush(lp)
      endif
      call restart_in3d(temp,  2*kdm, ip, 'temp    ')
      if (mnproc.eq.1) then
        write(lp,*)'DBI: (restart_in) temp got!'
        call flush(lp)
      endif
      call restart_in3d(saln,  2*kdm, ip, 'saln    ')
      if (mnproc.eq.1) then
        write(lp,*)'DBI: (restart_in) saln got!'
        call flush(lp)
      endif
      call restart_in3d(th3d,  2*kdm, ip, 'th3d    ')
      if (mnproc.eq.1) then
        write(lp,*)'DBI: (restart_in) th3d got!'
        call flush(lp)
      endif
      if (mxlmy) then
        call restart_in3d(q2    ,2*kdm+4, ip, 'q2      ')
        call restart_in3d(q2l   ,2*kdm+4, ip, 'q2l     ')
        call restart_in3d(vctymy,  kdm+2, ip, 'vctymy  ')
        call restart_in3d(difqmy,  kdm+2, ip, 'difqmy  ')
        call restart_in3d(diftmy,  kdm+2, ip, 'diftmy  ')
      endif
      call restart_in3d(ubavg,     3, iu, 'ubavg   ')
      if (mnproc.eq.1) then
        write(lp,*)'DBI: (restart_in) ubavg got!'
        call flush(lp)
      endif
      call restart_in3d(vbavg,     3, iv, 'vbavg   ')
      if (mnproc.eq.1) then
        write(lp,*)'DBI: (restart_in) vbavg got!'
        call flush(lp)
      endif
      call restart_in3d(pbavg,     3, ip, 'pbavg   ')
      call restart_in3d(pbot,      1, ip, 'pbot    ')
      call restart_in3d(psikk,     1, ip, 'psikk   ')
      call restart_in3d(thkk,      1, ip, 'thkk    ')
      call restart_in3d(dpmixl,    2, ip, 'dpmixl  ')
      if (mnproc.eq.1) then
        write(lp,*)'DBI: (restart_in) dpmixl got!'
        call flush(lp)
      endif
      if (mnproc.eq.1) then
        write(lp,*)'DBI: (restart_in) icegln = ',icegln
        call flush(lp)
      endif
      if (icegln) then
        call zagetc(cline,ios, 11)
        if     (ios.ne.0) then
          if     (mnproc.eq.1) then
            write(lp,'(/ a,i4,i9 /)')
     &        'I/O error from zagetc, iunit,ios = ',11,ios
          endif !1st tile
          call xcstop('(restart_in)')
                 stop '(restart_in)'
        endif
        if     (ios.ne.0 .or. cline(1:8).ne.'temice  ') then
c
c ---     assume this is an addition of ice to the simulation.
c
          if     (mnproc.eq.1) then
          write(lp,'(/ a /)') 'adding ice to the simulation.'
          call flush(lp)
          endif !1st tile
c
          do j= 1,jj
            do i= 1,ii
              temice(i,j) = temp(i,j,1,1)
              covice(i,j) = 0.0
              thkice(i,j) = 0.0
            enddo
          enddo
          if     (trcrin .and. cline(1:8).eq.'tracer  ') then
c ---       reposition file for tracer input
            if     (mnproc.eq.1) then  ! .b file from 1st tile only
              rewind(11)
            endif
            do k= 1,12*kdm+16
              call zagetc(cline,ios, 11)
              if     (ios.ne.0) then
                if     (mnproc.eq.1) then
                  write(lp,'(/ a,i4,i9 /)')
     &              'I/O error from zagetc, iunit,ios = ',11,ios
                endif !1st tile
                call xcstop('(restart_in)')
                       stop '(restart_in)'
              endif
            enddo
          endif
        else
c
c ---     reposition file for ice input
c
          if     (mnproc.eq.1) then  ! .b file from 1st tile only
            rewind(11)
          endif
          do k= 1,12*kdm+16
            call zagetc(cline,ios, 11)
            if     (ios.ne.0) then
              if     (mnproc.eq.1) then
                write(lp,'(/ a,i4,i9 /)')
     &            'I/O error from zagetc, iunit,ios = ',11,ios
              endif !1st tile
              call xcstop('(restart_in)')
                     stop '(restart_in)'
            endif
*           if     (mnproc.eq.1) then
*           write(lp,'(a)') cline
*           endif !1st tile
          enddo
          call restart_in3d(temice,    1, ip, 'temice  ')
          call restart_in3d(covice,    1, ip, 'covice  ')
          call restart_in3d(thkice,    1, ip, 'thkice  ')
        endif
      endif
      if (trcrin) then
        do ktr= 1,ntracr
          call restart_in3d(tracer(1-nbdy,1-nbdy,1,1,ktr),
     &                             2*kdm, ip, 'tracer  ')
        enddo
      endif
      if     (mnproc.eq.1) then  ! .b file from 1st tile only
        close (unit=11)
      endif
      call zaiocl(11)

      if (mnproc.eq.1) then
        write(lp,*)'DBI: (restart_in) DONE! ...'
        call flush(lp)
      endif

      return
      end subroutine restart_in

      subroutine restart_in3d(field,l, mask, cfield)
      use mod_xc  ! HYCOM communication interface
      use mod_za  ! HYCOM I/O interface
      implicit none
c
      integer   l
      real,    dimension (1-nbdy:idm+nbdy,1-nbdy:jdm+nbdy,l) ::
     & field
      integer, dimension (1-nbdy:idm+nbdy,1-nbdy:jdm+nbdy) ::
     & mask
      character cfield*8
c
c --- read a single restart 3-d array field from unit 11.
c
      integer   i,ios,layer,level,k
      real      hmina(2*kdm+4),hminb,hmaxa(2*kdm+4),hmaxb
      character cline*80
c
      if     (mnproc.eq.1) then
        write(lp,'(a,i3,2x,a)') 'restart_in3d - l,cfield = ',l,cfield
       call flush(lp)
      endif !1st tile
      call zaiord3(field,l, mask,.false., hmina,hmaxa, 11)
c
      do k= 1,l
        call zagetc(cline,ios, 11)
        if     (ios.ne.0) then
          if     (mnproc.eq.1) then
            write(lp,'(/ a,i4,i9 /)')
     &        'I/O error from zagetc, iunit,ios = ',11,ios
          endif !1st tile
          call xcstop('(restart_in3d)')
                 stop '(restart_in3d)'
        endif
*       if     (mnproc.eq.1) then
*       write (lp,'(a)')  cline(1:len_trim(cline))
*       endif !1st tile
        if     (cline(1:8).ne.cfield) then
          if     (mnproc.eq.1) then
          write(lp,'(/ a / a,a /)') cline(1:len_trim(cline)),
     &           'error in restart_in3d - expected ',cfield
          endif !1st tile
          call xcstop('(restart_in3d)')
                 stop '(restart_in3d)'
        endif
        i = index(cline,'=')
        read (cline(i+1:),*) layer,level,hminb,hmaxb
        if     (abs(hmina(k)-hminb).gt.abs(hminb)*1.e-4 .or.
     &          abs(hmaxa(k)-hmaxb).gt.abs(hmaxb)*1.e-4     ) then
          if     (mnproc.eq.1) then
          write(lp,'(/ a / a,3i3 / a / a,1p3e14.6 / a,1p3e14.6 /)')
     &      'error - .a and .b files not consistent:',
     &      'iunit,k,l = ',11,k,l,
     &      cline,
     &      '.a,.b min = ',hmina(k),hminb,hmina(k)-hminb,
     &      '.a,.b max = ',hmaxa(k),hmaxb,hmaxa(k)-hmaxb
          endif !1st tile
          call xcstop('(restart_in3d)')
                 stop '(restart_in3d)'
        endif
      enddo
c
      return
      end subroutine restart_in3d

      subroutine restart_out(nstepx, dtimex, last)
      use mod_xc  ! HYCOM communication interface
      use mod_za  ! HYCOM I/O interface
      implicit none
c
!DBI:      include 'common_blocks.h'
c
      logical last
      integer nstepx
      real*8  dtimex
c
c     write out in a restart file on unit 12 or 22 (and a flux file on 25).
c
      logical   lopen
      integer   i,iunit,j,k,ktr,l
      real      xmin(2*kdm+4),xmax(2*kdm+4)
      character cline*80

!DBI: output fluxes to a 'regular' binary file ('flnmflx'.bin) via thess
!     temporary arrays:
      real*4, dimension(itdm,jtdm,kdm) :: fout
      real,   dimension(itdm,jtdm)     :: bchk
!----
c
      integer, save :: icount = 0
c
      icount = icount + 1
c
      if     (last .or. mod(icount,2).eq.0) then
        iunit = 12  ! standard restart file
      else
        iunit = 22  ! backup   restart file
      endif
c
      call zaiopi(lopen, iunit)
      if (.not.lopen) then
        if     (iunit.eq.12) then
          !DBI: call zaiopf(flnmrso(1:len_trim(flnmrso))//'.a','new', iunit)
         call zaiopf(flnmrso(1:len_trim(flnmrso)),'unknown', iunit)
        else
          !DBI: call zaiopf(flnmrso(1:len_trim(flnmrso))//'1.a','new', iunit)
         call zaiopf(flnmrso(1:len_trim(flnmrso))//'_1','unknown', iunit)
        endif
        if     (mnproc.eq.1) then
          if     (iunit.eq.12) then
            open (unit=iunit,file=flnmrsoh(1:len_trim(flnmrsoh)),
 !DBI:    &            status='new',action='write',form='formatted')
     &            status='unknown',action='write',form='formatted')
            write(lp,'(a)') ' creating a new standard restart file'
          else
            open (unit=iunit,file=flnmrsoh(1:len_trim(flnmrsoh))//'_1',
 !DBI:    &            status='new',action='write',form='formatted')
     &            status='unknown',action='write',form='formatted')
            write(lp,'(a)') ' creating a new backup   restart file'
          endif
          call flush(lp)
        endif !1st tile
      else
        call zaiorw(iunit)
        if     (mnproc.eq.1) then
          rewind(unit=iunit)
          if     (iunit.eq.12) then
            write(lp,'(a)') 
     &        ' over-writing any previous standard restart'
          else
            write(lp,'(a)') 
     &        ' over-writing any previous backup   restart'
          endif
          call flush(lp)
        endif !1st tile
      endif
c
      if     (mnproc.eq.1) then
      write(iunit,'(a,3i6)') 'RESTART: iexpt,iversn,yrflag = ',
     &                              iexpt,iversn,yrflag
      write(cline,*)                nstepx,dtimex
      write(iunit,'(a,a)')   'RESTART: nstep,dtime = ',
     &                              cline(1:len_trim(cline))
      call flush(iunit)
      endif !1st tile
c
      call zaiowr3(u,      2*kdm, iu,.false., xmin,xmax, iunit,.true.)
!!!!!!call xctilr( u,    1,2*kdm, nbdy,nbdy, halo_uv)
!!!!  "unroll" recursive calls to xctilr
      call xctilr( u(1-nbdy,1-nbdy,1,1),    1,kdm, nbdy,nbdy, halo_uv)
      call xctilr( u(1-nbdy,1-nbdy,1,2),    1,kdm, nbdy,nbdy, halo_uv)
      if     (mnproc.eq.1) then
      do l= 0,1
        do k= 1,kdm
          write(iunit,4100) 'u       ',k,l+1,xmin(k+l*kdm),xmax(k+l*kdm)
        enddo
      enddo
      call flush(iunit)
      endif !1st tile
      call zaiowr3(v,      2*kdm, iv,.false., xmin,xmax, iunit,.true.)
!!!!  call xctilr( v,    1,2*kdm, nbdy,nbdy, halo_vv)
!!!!  "unroll" recursive calls to xctilr
      call xctilr( v(1-nbdy,1-nbdy,1,1),    1,kdm, nbdy,nbdy, halo_vv)
      call xctilr( v(1-nbdy,1-nbdy,1,2),    1,kdm, nbdy,nbdy, halo_vv)
      if     (mnproc.eq.1) then
      do l= 0,1
        do k= 1,kdm
          write(iunit,4100) 'v       ',k,l+1,xmin(k+l*kdm),xmax(k+l*kdm)
        enddo
      enddo
      call flush(iunit)
      endif !1st tile
      call zaiowr3(dp,     2*kdm, ip,.false., xmin,xmax, iunit,.true.)
!!!!  "unroll" recursive calls to xctilr
!!!!  call xctilr( dp,   1,2*kdm, nbdy,nbdy, halo_ps)
      call xctilr( dp(1-nbdy,1-nbdy,1,1),   1,kdm, nbdy,nbdy, halo_ps)
      call xctilr( dp(1-nbdy,1-nbdy,1,2),   1,kdm, nbdy,nbdy, halo_ps)
      if     (mnproc.eq.1) then
      do l= 0,1
        do k= 1,kdm
          write(iunit,4100) 'dp      ',k,l+1,xmin(k+l*kdm),xmax(k+l*kdm)
        enddo
      enddo
      call flush(iunit)
      endif !1st tile
      call zaiowr3(temp,   2*kdm, ip,.false., xmin,xmax, iunit,.true.)
!!!!  "unroll" recursive calls to xctilr
!!!!  call xctilr( temp, 1,2*kdm, nbdy,nbdy, halo_ps)
      call xctilr( temp(1-nbdy,1-nbdy,1,1), 1,kdm, nbdy,nbdy, halo_ps)
      call xctilr( temp(1-nbdy,1-nbdy,1,2), 1,kdm, nbdy,nbdy, halo_ps)
      if     (mnproc.eq.1) then
      do l= 0,1
        do k= 1,kdm
          write(iunit,4100) 'temp    ',k,l+1,xmin(k+l*kdm),xmax(k+l*kdm)
        enddo
      enddo
      call flush(iunit)
      endif !1st tile
      call zaiowr3(saln,   2*kdm, ip,.false., xmin,xmax, iunit,.true.)
!!!!  "unroll" recursive calls to xctilr
!!!!  call xctilr( saln, 1,2*kdm, nbdy,nbdy, halo_ps)
      call xctilr( saln(1-nbdy,1-nbdy,1,1), 1,kdm, nbdy,nbdy, halo_ps)
      call xctilr( saln(1-nbdy,1-nbdy,1,2), 1,kdm, nbdy,nbdy, halo_ps)
      if     (mnproc.eq.1) then
      do l= 0,1
        do k= 1,kdm
          write(iunit,4100) 'saln    ',k,l+1,xmin(k+l*kdm),xmax(k+l*kdm)
        enddo
      enddo
      call flush(iunit)
      endif !1st tile
      call zaiowr3(th3d,   2*kdm, ip,.false., xmin,xmax, iunit,.true.)
!!!!  "unroll" recursive calls to xctilr
!!!!  call xctilr( th3d, 1,2*kdm, nbdy,nbdy, halo_ps)
      call xctilr( th3d(1-nbdy,1-nbdy,1,1), 1,kdm, nbdy,nbdy, halo_ps)
      call xctilr( th3d(1-nbdy,1-nbdy,1,2), 1,kdm, nbdy,nbdy, halo_ps)
      if     (mnproc.eq.1) then
      do l= 0,1
        do k= 1,kdm
          write(iunit,4100) 'th3d    ',k,l+1,xmin(k+l*kdm),xmax(k+l*kdm)
        enddo
      enddo
      call flush(iunit)
      endif !1st tile
c
      if (mxlmy) then
        call zaiowr3(q2, 2*kdm+4, ip,.false., xmin,xmax, iunit,.true.)
        if     (mnproc.eq.1) then
        do l= 0,1
          do k= 1,kdm+2
            write(iunit,4100) 'q2      '
     &                    ,k,l+1,xmin(k+l*(kdm+2)),xmax(k+l*(kdm+2))
          enddo
        enddo
        call flush(iunit)
        endif !1st tile
        call zaiowr3(q2l, 2*kdm+4, ip,.false., xmin,xmax, iunit,.true.)
        if     (mnproc.eq.1) then
        do l= 0,1
          do k= 1,kdm+2
            write(iunit,4100) 'q2l     '
     &                    ,k,l+1,xmin(k+l*(kdm+2)),xmax(k+l*(kdm+2))
          enddo
        enddo
        call flush(iunit)
        endif !1st tile
        call zaiowr3(vctymy, kdm+2, ip,.false., xmin,xmax, iunit,.true.)
        if     (mnproc.eq.1) then
        do l= 1,1
          do k= 1,kdm+2
            write(iunit,4100) 'vctymy  ',k,l,xmin(k),xmax(k)
          enddo
        enddo
        call flush(iunit)
        endif !1st tile
        call zaiowr3(difqmy, kdm+2, ip,.false., xmin,xmax, iunit,.true.)
        if     (mnproc.eq.1) then
        do l= 1,1
          do k= 1,kdm+2
            write(iunit,4100) 'difqmy  ',k,l,xmin(k),xmax(k)
          enddo
        enddo
        call flush(iunit)
        endif !1st tile
        call zaiowr3(diftmy, kdm+2, ip,.false., xmin,xmax, iunit,.true.)
        if     (mnproc.eq.1) then
        do l= 1,1
          do k= 1,kdm+2
            write(iunit,4100) 'diftmy  ',k,l,xmin(k),xmax(k)
          enddo
        enddo
        call flush(iunit)
        endif !1st tile
      endif
c
      call zaiowr3(ubavg,      3, iu,.false., xmin,xmax, iunit,.true.)
      call xctilr( ubavg,    1,3, nbdy,nbdy, halo_uv)
      if     (mnproc.eq.1) then
      do l= 1,3
        do k= 0,0
          write(iunit,4100) 'ubavg   ',k,l,  xmin(l),xmax(l)
        enddo
      enddo
      call flush(iunit)
      endif !1st tile
      call zaiowr3(vbavg,      3, iv,.false., xmin,xmax, iunit,.true.)
      call xctilr( vbavg,    1,3, nbdy,nbdy, halo_vv)
      if     (mnproc.eq.1) then
      do l= 1,3
        do k= 0,0
          write(iunit,4100) 'vbavg   ',k,l,  xmin(l),xmax(l)
        enddo
      enddo
      call flush(iunit)
      endif !1st tile
      call zaiowr3(pbavg,      3, ip,.false., xmin,xmax, iunit,.true.)
      call xctilr( pbavg,    1,3, nbdy,nbdy, halo_ps)
      if     (mnproc.eq.1) then
      do l= 1,3
        do k= 0,0
          write(iunit,4100) 'pbavg   ',k,l,  xmin(l),xmax(l)
        enddo
      enddo
      call flush(iunit)
      endif !1st tile
      call zaiowr3(pbot,       1, ip,.false., xmin,xmax, iunit,.true.)
      call xctilr( pbot,     1,1, nbdy,nbdy, halo_ps)
      if     (mnproc.eq.1) then
      do l= 1,1
        do k= 0,0
          write(iunit,4100) 'pbot    ',k,l,  xmin(l),xmax(l)
        enddo
      enddo
      call flush(iunit)
      endif !1st tile
      call zaiowr3(psikk,      1, ip,.false., xmin,xmax, iunit,.true.)
      call xctilr( psikk,    1,1, nbdy,nbdy, halo_ps)
      if     (mnproc.eq.1) then
      do l= 1,1
        do k= 0,0
          write(iunit,4100) 'psikk   ',k,l,  xmin(l),xmax(l)
        enddo
      enddo
      call flush(iunit)
      endif !1st tile
      call zaiowr3(thkk,       1, ip,.false., xmin,xmax, iunit,.true.)
      call xctilr( thkk,     1,1, nbdy,nbdy, halo_ps)
      if     (mnproc.eq.1) then
      do l= 1,1
        do k= 0,0
          write(iunit,4100) 'thkk    ',k,l,  xmin(l),xmax(l)
        enddo
      enddo
      call flush(iunit)
      endif !1st tile
      call zaiowr3(dpmixl,     2, ip,.false., xmin,xmax, iunit,.true.)
      call xctilr( dpmixl,   1,2, nbdy,nbdy, halo_ps)
      if     (mnproc.eq.1) then
      do l= 1,2
        do k= 0,0
          write(iunit,4100) 'dpmixl  ',k,l,  xmin(l),xmax(l)
        enddo
      enddo
      call flush(iunit)
      endif !1st tile
      if (icegln) then
        call zaiowr3(temice,     1, ip,.false., xmin,xmax, iunit,.true.)
        call xctilr( temice,   1,1, nbdy,nbdy, halo_ps)
        if     (mnproc.eq.1) then
        do l= 1,1
          do k= 0,0
            write(iunit,4100) 'temice  ',k,l,  xmin(l),xmax(l)
          enddo
        enddo
        call flush(iunit)
        endif !1st tile
        call zaiowr3(covice,     1, ip,.false., xmin,xmax, iunit,.true.)
        call xctilr( covice,   1,1, nbdy,nbdy, halo_ps)
        if     (mnproc.eq.1) then
        do l= 1,1
          do k= 0,0
            write(iunit,4100) 'covice  ',k,l,  xmin(l),xmax(l)
          enddo
        enddo
        call flush(iunit)
        endif !1st tile
        call zaiowr3(thkice,     1, ip,.false., xmin,xmax, iunit,.true.)
        call xctilr( thkice,   1,1, nbdy,nbdy, halo_ps)
        if     (mnproc.eq.1) then
        do l= 1,1
          do k= 0,0
            write(iunit,4100) 'thkice  ',k,l,  xmin(l),xmax(l)
          enddo
        enddo
        call flush(iunit)
        endif !1st tile
      endif
      if (trcout) then
        do ktr= 1,ntracr
          call zaiowr3(tracer(1-nbdy,1-nbdy,1,1,ktr),  2*kdm,
     &                 ip,.false., xmin,xmax, iunit,.true.)
!!!!  "unroll" recursive calls to xctilr
!!!!      call xctilr( tracer(1-nbdy,1-nbdy,1,1,ktr),1,2*kdm,
!!!! &                  nbdy,nbdy, halo_ps)
          call xctilr( tracer(1-nbdy,1-nbdy,1,1,ktr),1,kdm,
     &                  nbdy,nbdy, halo_ps)
          call xctilr( tracer(1-nbdy,1-nbdy,1,2,ktr),1,kdm,
     &                  nbdy,nbdy, halo_ps)
          if     (mnproc.eq.1) then
          do l= 0,1
            do k= 1,kdm
              write(iunit,4100) 'tracer  ',k,l+1,xmin(k+l*kdm),
     &                                        xmax(k+l*kdm)
            enddo
          enddo
          call flush(iunit)
          endif !1st tile
        enddo !ktr
      endif !trcout
      call zaiofl(iunit)
      if     (mnproc.eq.1) then
      call flush( iunit)
      write(lp,'(a,f11.2)') ' restart created at model day',dtimex
      call flush(lp)
      endif !1st tile
!DBI: close these restartfile so that the next restartfile can be written
!     (to a new name!)
      if     (mnproc.eq.1) then  ! .b file from 1st tile only
        close (unit=iunit)
      endif
      call zaiocl(iunit)
!------------------------------------------------------------------------
      call xcsync(no_flush) !DBI!
c
c --- output to flux file
c
      if (.FALSE.) then ! turn on/off flux output
      !if (.TRUE.) then ! turn on/off flux output
        call zaiopi(lopen, 25)
        if (.not.lopen) then
 !DBI:         call zaiopf(flnmflx(1:len_trim(flnmflx))//'.a','new', 25)
          call zaiopf(flnmflx(1:len_trim(flnmflx))//'.a','unknown', 25)
          if     (mnproc.eq.1) then
          open (unit=25,file=flnmflx(1:len_trim(flnmflx))//'.b',
 !DBI:    &          status='new',action='write',form='formatted')
     &          status='unknown',action='write',form='formatted')
          write(25,'(a,3i6)') 'FLUXES: iexpt,iversn,yrflag = ',
     &                                 iexpt,iversn,yrflag
          call flush(25)
          endif !1st tile
        endif
c
        if     (mnproc.eq.1) then
        write(cline,*)               nstepx,dtimex
        write(25,'(a,a)')   'FLUXES: nstep,dtime = ',
     &                               cline(1:len_trim(cline))
        call flush(25)
        endif !1st tile
c
        call zaiowr3(dpav,     kdm, ip,.true.,  xmin,xmax, 25, .false.)
        if     (mnproc.eq.1) then
        do l= 0,0
          do k= 1,kdm
            write(25,4100) 'dpav    ',k,l,  xmin(k+l*kdm),xmax(k+l*kdm)
          enddo
        enddo
        call flush(25)
        endif !1st tile
        call zaiowr3(uflxav,   kdm, iu,.true.,  xmin,xmax, 25, .false.)
        if     (mnproc.eq.1) then
        do l= 0,0
          do k= 1,kdm
            write(25,4100) 'uflxav  ',k,l,  xmin(k+l*kdm),xmax(k+l*kdm)
          enddo
        enddo
        call flush(25)
        endif !1st tile
        call zaiowr3(vflxav,   kdm, iv,.true.,  xmin,xmax, 25, .false.)
        if     (mnproc.eq.1) then
        do l= 0,0
          do k= 1,kdm
            write(25,4100) 'vflxav  ',k,l,  xmin(k+l*kdm),xmax(k+l*kdm)
          enddo
        enddo
        call flush( 25)
        endif !1st tile
        call zaiofl(25)
!
!DBI:-- close these restartfile so that the next restartfile can be written
!       (to a new name!)
        if (mnproc.eq.1) then  ! .b file from 1st tile only
          close (unit=25)
        endif
        call zaiocl(25)
!------------------------------------------------------------------------
        call xcsync(no_flush) !DBI!
      endif !flux output

      IF (.TRUE.) THEN           !DBI: may output a regular binary file!
        do k = 1, kdm
          call xcaget(bchk,dpav(:,:,k),0)
          fout(:,:,k) = bchk
        enddo
        !DBI: if only mnproc==1 is used for the follow open and write
        !     we seem not to be able to get (eg, 12) individual fluxfiles as
        !     expected, ie, the first fluxfile would be used repeatedly and
        !     is 'renewed' and finally we only get the last month result!
        !     (weird... WHY?!)    ----------- this is not true -------------
        if (mnproc==1) then
        open(33,file=trim(flnmflx)//'.bin',status='unknown',
     +                                      form='unformatted')
        write(lp,'(2a)')'DBI: (restart_out) writing fluxfile ',
     +                                 trim(flnmflx)//'.bin'
        call flush(lp)
        write(33)fout
        call flush(33)
        endif
        do k = 1, kdm
          call xcaget(bchk,uflxav(:,:,k),0)
          fout(:,:,k) = bchk
        enddo
        if (mnproc==1) then
        write(33)fout
        call flush(33)
        endif
        do k = 1, kdm
          call xcaget(bchk,vflxav(:,:,k),0)
          fout(:,:,k) = bchk
        enddo
        if (mnproc==1) then
        write(33)fout
        call flush(33)
        close(33)
        endif
      ENDIF    !output regular fluxfile or not!
c
!$OMP PARALLEL DO PRIVATE(j,k,l,i)
!$OMP&         SCHEDULE(STATIC,jblk)
      do j=1-nbdy,jj+nbdy
        do k=1,kk
          do i=1-nbdy,ii+nbdy
              dpav(i,j,k)=0.
            uflxav(i,j,k)=0.
            vflxav(i,j,k)=0.
          enddo
        enddo
      enddo
!$OMP END PARALLEL DO
c
      return
 4100 format(a,': layer,tlevel,range = ',i3,i3,2x,1p2e16.7)
      end subroutine restart_out
